#pragma once

#include <freertos/FreeRTOS.h>
#include <freertos/semphr.h>
#include <freertos/task.h>

#include "messages.pb.h"
#include "sx127x_driver.h"

typedef struct ugv_comms_state_s {
  sx127x_hndl  lora;
  TaskHandle_t task_handle;

  SemaphoreHandle_t mutex;
  uas_ugv_Location  location;
  uas_ugv_UGV_State ugv_state;
  TickType_t        last_packet_tick;
  int32_t           last_packet_rssi;
  int8_t            last_packet_snr;
} ugv_comms_state_t;

ugv_comms_state_t ugv_comms_state;

void ugv_comms_init();
